/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __AGENT_APP_H__
#define __AGENT_APP_H__

#include <glib.h>
#include "agent-server.h"

G_BEGIN_DECLS

#define AGENT_TYPE_APP			(agent_app_get_type ())
#define AGENT_APP(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), AGENT_TYPE_APP, AgentApp))
#define AGENT_APP_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), AGENT_TYPE_APP, AgentAppClass))
#define AGENT_IS_APP(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), AGENT_TYPE_APP))
#define AGENT_IS_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), AGENT_TYPE_APP))
#define AGENT_APP_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), AGENT_TYPE_APP, AgentAppClass))

typedef struct _AgentApp	AgentApp;
typedef struct _AgentAppClass	AgentAppClass;
typedef struct _AgentAppPrivate	AgentAppPrivate;

struct _AgentApp
{
  GObject parent;
  AgentAppPrivate *priv;
};

struct _AgentAppClass
{
  GObjectClass parent;
};

GType		agent_app_get_type		(void);

AgentApp*	agent_app_new			(void);
AgentApp*	agent_app_get			(void);

gboolean	agent_app_load_config_file	(AgentApp    *app,
						 const gchar *filename);
time_t		agent_app_get_uptime		(AgentApp    *app);
AgentServer*	agent_app_get_server		(AgentApp    *app);

gboolean	agent_app_start			(AgentApp    *app);
void		agent_app_quit			(AgentApp    *app);

G_END_DECLS

#endif /* __AGENT_APP_H__ */
