/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __AGENT_SERVER_H__
#define __AGENT_SERVER_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define AGENT_TYPE_SERVER		(agent_server_get_type ())
#define AGENT_SERVER(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), AGENT_TYPE_SERVER, AgentServer))
#define AGENT_SERVER_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), AGENT_TYPE_SERVER, AgentServerClass))
#define AGENT_IS_SERVER(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), AGENT_TYPE_SERVER))
#define AGENT_IS_SERVER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), AGENT_TYPE_SERVER))
#define AGENT_SERVER_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), AGENT_TYPE_SERVER, AgentServerClass))

typedef struct _AgentServer		AgentServer;
typedef struct _AgentServerClass	AgentServerClass;
typedef struct _AgentServerPrivate	AgentServerPrivate;

typedef enum
{
  SERVER_TYPE_PEER        = 0,
  SERVER_TYPE_BUS_SESSION = 1,
  SERVER_TYPE_BUS_SYSTEM  = 2,
} AgentServerType;

struct _AgentServer
{
  GObject parent;
  AgentServerPrivate *priv;
};

struct _AgentServerClass
{
  GObjectClass parent;
};

GType		agent_server_get_type		(void);

AgentServer*	agent_server_new		(void);

void		agent_server_set_max_threads	(AgentServer     *server,
						 gint             max_threads);
void		agent_server_set_auth_anonymous	(AgentServer     *server,
						 gboolean         anonymous);

gboolean	agent_server_start		(AgentServer     *server,
						 AgentServerType  type,
						 const gchar     *address);
void		agent_server_stop		(AgentServer     *server);

G_END_DECLS

#endif /* __AGENT_SERVER_H__ */
