#!/bin/bash
#
# Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
# All rights reserved.
#
# ttyutils setup script.
#
xdg_data_dir=/opt/ttyutils/share/glook-xdg-data

# install ttyglook runtime icons.
#
xdg-icon-resource install --context mimetypes --size 16 ${xdg_data_dir}/mime-ttylook-16.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 22 ${xdg_data_dir}/mime-ttylook-22.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 24 ${xdg_data_dir}/mime-ttylook-24.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 32 ${xdg_data_dir}/mime-ttylook-32.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 48 ${xdg_data_dir}/mime-ttylook-48.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 64 ${xdg_data_dir}/mime-ttylook-64.png application-x-ttylook
xdg-icon-resource install --context mimetypes --size 16 ${xdg_data_dir}/mime-ttyagent-16.png ttyutils-ttyagent
xdg-icon-resource install --context mimetypes --size 24 ${xdg_data_dir}/mime-ttyagent-24.png ttyutils-ttyagent
xdg-icon-resource install --context mimetypes --size 32 ${xdg_data_dir}/mime-ttyagent-32.png ttyutils-ttyagent
xdg-icon-resource install --context mimetypes --size 48 ${xdg_data_dir}/mime-ttyagent-48.png ttyutils-ttyagent
xdg-icon-resource install --context mimetypes --size 16 ${xdg_data_dir}/mime-local-16.png ttyutils-local
xdg-icon-resource install --context mimetypes --size 22 ${xdg_data_dir}/mime-local-22.png ttyutils-local
xdg-icon-resource install --context actions   --size 16 ${xdg_data_dir}/accelerator-16.png ttyutils-accelerator
xdg-icon-resource install --context actions   --size 24 ${xdg_data_dir}/bookmark-24.png ttyutils-bookmark
xdg-icon-resource install --context actions   --size 24 ${xdg_data_dir}/bookmark-silver-24.png ttyutils-bookmark-silver
xdg-icon-resource install --context places    --size 16 ${xdg_data_dir}/internet-16.png ttyutils-internet
xdg-icon-resource install --context places    --size 24 ${xdg_data_dir}/internet-24.png ttyutils-internet

# register ttyutils mime type.
#
xdg-mime install ${xdg_data_dir}/ttyutils-glook.mime.xml

# install a desktop menu item.
#
xdg-desktop-menu install ${xdg_data_dir}/ttyutils-glook.desktop

# generate wrapper scripts.
gen_wrapper() {
    cat >> /opt/ttyutils/$1 <<EOF
#!/bin/sh

export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/opt/ttyutils/lib
/opt/ttyutils/bin/$1 "$@"
EOF
}
gen_wrapper ttyagent
gen_wrapper ttyglook
gen_wrapper ttylook
gen_wrapper ttyplay
gen_wrapper ttyrcd

exit

# append /opt/ttyutils/lib to LD_LIBRARY_PATH env.
# append /opt/ttyutils/bin to PATH env.
#
grep -q "/opt/ttyutils/profile" ~/.bashrc
if [ $? -ne 0 ] ; then
	cat >> ~/.bashrc <<EOF

# The following three lines have been added by Ttyutils.
if [ -f /opt/ttyutils/profile ]; then
   . /opt/ttyutils/profile
fi
EOF
. ~/.bashrc
fi
