/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_ACCEL_MAP_H__
#define __GLOOK_ACCEL_MAP_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_ACCEL_MAP		(glook_accel_map_get_type ())
#define GLOOK_ACCEL_MAP(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_ACCEL_MAP, GLookAccelMap))
#define GLOOK_ACCEL_MAP_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_ACCEL_MAP, GLookAccelMapClass))
#define GLOOK_IS_ACCEL_MAP(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_ACCEL_MAP))
#define GLOOK_IS_ACCEL_MAP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_ACCEL_MAP))
#define GLOOK_ACCEL_MAP_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_ACCEL_MAP, GLookAccelMapClass))

typedef struct _GLookAccelMap		GLookAccelMap;
typedef struct _GLookAccelMapClass	GLookAccelMapClass;
typedef struct _GLookAccelMapPriv	GLookAccelMapPriv;

struct _GLookAccelMap
{
  GObject parent;
  GLookAccelMapPriv *priv;
};

struct _GLookAccelMapClass
{
  GObjectClass parent_class;
};

#define GLOOK_ACCEL_PATH		"<GLook-Window>/accel/"
#define GLOOK_ACCEL_PATH_NEW_TAB	g_intern_static_string(GLOOK_ACCEL_PATH "new-tab")
#define GLOOK_ACCEL_PATH_NEW_WINDOW	g_intern_static_string(GLOOK_ACCEL_PATH "new-window")
#define GLOOK_ACCEL_PATH_PLAY_FILE	g_intern_static_string(GLOOK_ACCEL_PATH "play-file")
#define GLOOK_ACCEL_PATH_SHOW_CONTROL	g_intern_static_string(GLOOK_ACCEL_PATH "show-control")
#define GLOOK_ACCEL_PATH_CLOSE_WINDOW	g_intern_static_string(GLOOK_ACCEL_PATH "close-window")
#define GLOOK_ACCEL_PATH_QUIT		g_intern_static_string(GLOOK_ACCEL_PATH "quit")
#define GLOOK_ACCEL_PATH_COPY		g_intern_static_string(GLOOK_ACCEL_PATH "copy")
#define GLOOK_ACCEL_PATH_PASTE		g_intern_static_string(GLOOK_ACCEL_PATH "paste")
#define GLOOK_ACCEL_PATH_SELECT_ALL	g_intern_static_string(GLOOK_ACCEL_PATH "select-all")
#define GLOOK_ACCEL_PATH_RELOAD		g_intern_static_string(GLOOK_ACCEL_PATH "reload")
#define GLOOK_ACCEL_PATH_ZOOM_IN	g_intern_static_string(GLOOK_ACCEL_PATH "zoom-in")
#define GLOOK_ACCEL_PATH_ZOOM_OUT	g_intern_static_string(GLOOK_ACCEL_PATH "zoom-out")
#define GLOOK_ACCEL_PATH_ZOOM_100	g_intern_static_string(GLOOK_ACCEL_PATH "zoom-100")
#define GLOOK_ACCEL_PATH_WRITABLE	g_intern_static_string(GLOOK_ACCEL_PATH "writable")
#define GLOOK_ACCEL_PATH_SAVE_SCREEN	g_intern_static_string(GLOOK_ACCEL_PATH "save-screen")
#define GLOOK_ACCEL_PATH_SUSPENSION	g_intern_static_string(GLOOK_ACCEL_PATH "suspension")
#define GLOOK_ACCEL_PATH_DISCONNECT	g_intern_static_string(GLOOK_ACCEL_PATH "disconnect")
#define GLOOK_ACCEL_PATH_CLOSE_TAB	g_intern_static_string(GLOOK_ACCEL_PATH "close-tab")
#define GLOOK_ACCEL_PATH_TAB_1		g_intern_static_string(GLOOK_ACCEL_PATH "tab-1")
#define GLOOK_ACCEL_PATH_TAB_2		g_intern_static_string(GLOOK_ACCEL_PATH "tab-2")
#define GLOOK_ACCEL_PATH_TAB_3		g_intern_static_string(GLOOK_ACCEL_PATH "tab-3")
#define GLOOK_ACCEL_PATH_TAB_4		g_intern_static_string(GLOOK_ACCEL_PATH "tab-4")
#define GLOOK_ACCEL_PATH_TAB_5		g_intern_static_string(GLOOK_ACCEL_PATH "tab-5")
#define GLOOK_ACCEL_PATH_TAB_6		g_intern_static_string(GLOOK_ACCEL_PATH "tab-6")
#define GLOOK_ACCEL_PATH_TAB_7		g_intern_static_string(GLOOK_ACCEL_PATH "tab-7")
#define GLOOK_ACCEL_PATH_TAB_8		g_intern_static_string(GLOOK_ACCEL_PATH "tab-8")
#define GLOOK_ACCEL_PATH_TAB_9		g_intern_static_string(GLOOK_ACCEL_PATH "tab-9")
#define GLOOK_ACCEL_PATH_LEFT_TAB	g_intern_static_string(GLOOK_ACCEL_PATH "left-tab")
#define GLOOK_ACCEL_PATH_RIGHT_TAB	g_intern_static_string(GLOOK_ACCEL_PATH "right-tab")
#define GLOOK_ACCEL_PATH_GET_START	g_intern_static_string(GLOOK_ACCEL_PATH "get-start")
#define GLOOK_ACCEL_PATH_RESOURCES	g_intern_static_string(GLOOK_ACCEL_PATH "resources")
#define GLOOK_ACCEL_PATH_ADDRESS_BAR	g_intern_static_string(GLOOK_ACCEL_PATH "address-bar")
#define GLOOK_ACCEL_PATH_PLAYBACK	g_intern_static_string(GLOOK_ACCEL_PATH "playback")
#define GLOOK_ACCEL_PATH_FORWARD	g_intern_static_string(GLOOK_ACCEL_PATH "forward")
#define GLOOK_ACCEL_PATH_BACKWARD	g_intern_static_string(GLOOK_ACCEL_PATH "backward")

/* same with above but without g_intern_static_string() */
#define _GLOOK_ACCEL_PATH_NEW_TAB	GLOOK_ACCEL_PATH "new-tab"
#define _GLOOK_ACCEL_PATH_NEW_WINDOW	GLOOK_ACCEL_PATH "new-window"
#define _GLOOK_ACCEL_PATH_PLAY_FILE	GLOOK_ACCEL_PATH "play-file"
#define _GLOOK_ACCEL_PATH_SHOW_CONTROL	GLOOK_ACCEL_PATH "show-control"
#define _GLOOK_ACCEL_PATH_CLOSE_WINDOW	GLOOK_ACCEL_PATH "close-window"
#define _GLOOK_ACCEL_PATH_QUIT		GLOOK_ACCEL_PATH "quit"
#define _GLOOK_ACCEL_PATH_COPY		GLOOK_ACCEL_PATH "copy"
#define _GLOOK_ACCEL_PATH_PASTE		GLOOK_ACCEL_PATH "paste"
#define _GLOOK_ACCEL_PATH_SELECT_ALL	GLOOK_ACCEL_PATH "select-all"
#define _GLOOK_ACCEL_PATH_RELOAD	GLOOK_ACCEL_PATH "reload"
#define _GLOOK_ACCEL_PATH_ZOOM_IN	GLOOK_ACCEL_PATH "zoom-in"
#define _GLOOK_ACCEL_PATH_ZOOM_OUT	GLOOK_ACCEL_PATH "zoom-out"
#define _GLOOK_ACCEL_PATH_ZOOM_100	GLOOK_ACCEL_PATH "zoom-100"
#define _GLOOK_ACCEL_PATH_WRITABLE	GLOOK_ACCEL_PATH "writable"
#define _GLOOK_ACCEL_PATH_SAVE_SCREEN	GLOOK_ACCEL_PATH "save-screen"
#define _GLOOK_ACCEL_PATH_SUSPENSION	GLOOK_ACCEL_PATH "suspension"
#define _GLOOK_ACCEL_PATH_DISCONNECT	GLOOK_ACCEL_PATH "disconnect"
#define _GLOOK_ACCEL_PATH_CLOSE_TAB	GLOOK_ACCEL_PATH "close-tab"
#define _GLOOK_ACCEL_PATH_TAB_1		GLOOK_ACCEL_PATH "tab-1"
#define _GLOOK_ACCEL_PATH_TAB_2		GLOOK_ACCEL_PATH "tab-2"
#define _GLOOK_ACCEL_PATH_TAB_3		GLOOK_ACCEL_PATH "tab-3"
#define _GLOOK_ACCEL_PATH_TAB_4		GLOOK_ACCEL_PATH "tab-4"
#define _GLOOK_ACCEL_PATH_TAB_5		GLOOK_ACCEL_PATH "tab-5"
#define _GLOOK_ACCEL_PATH_TAB_6		GLOOK_ACCEL_PATH "tab-6"
#define _GLOOK_ACCEL_PATH_TAB_7		GLOOK_ACCEL_PATH "tab-7"
#define _GLOOK_ACCEL_PATH_TAB_8		GLOOK_ACCEL_PATH "tab-8"
#define _GLOOK_ACCEL_PATH_TAB_9		GLOOK_ACCEL_PATH "tab-9"
#define _GLOOK_ACCEL_PATH_LEFT_TAB	GLOOK_ACCEL_PATH "left-tab"
#define _GLOOK_ACCEL_PATH_RIGHT_TAB	GLOOK_ACCEL_PATH "right-tab"
#define _GLOOK_ACCEL_PATH_GET_START	GLOOK_ACCEL_PATH "get-start"
#define _GLOOK_ACCEL_PATH_RESOURCES	GLOOK_ACCEL_PATH "resources"
#define _GLOOK_ACCEL_PATH_ADDRESS_BAR	GLOOK_ACCEL_PATH "address-bar"
#define _GLOOK_ACCEL_PATH_PLAYBACK	GLOOK_ACCEL_PATH "playback"
#define _GLOOK_ACCEL_PATH_FORWARD	GLOOK_ACCEL_PATH "forward"
#define _GLOOK_ACCEL_PATH_BACKWARD	GLOOK_ACCEL_PATH "backward"


GType		glook_accel_map_get_type		(void) G_GNUC_CONST;

void		glook_accel_map_reset			(void);

GLookAccelMap*	glook_accel_map_new			(GSettings *accel_settings);

GSettings*	glook_accel_map_get_settings		(GLookAccelMap *map);

void		glook_accel_map_set_new_tab		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_new_tab		(GLookAccelMap *map);
void		glook_accel_map_set_play_file		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_play_file		(GLookAccelMap *map);
void		glook_accel_map_set_new_window		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_new_window		(GLookAccelMap *map);
void		glook_accel_map_set_show_control	(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_show_control	(GLookAccelMap *map);
void		glook_accel_map_set_close_window	(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_close_window	(GLookAccelMap *map);
void		glook_accel_map_set_quit		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_quit		(GLookAccelMap *map);
void		glook_accel_map_set_copy		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_copy		(GLookAccelMap *map);
void		glook_accel_map_set_paste		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_paste		(GLookAccelMap *map);
void		glook_accel_map_set_select_all		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_select_all		(GLookAccelMap *map);
void		glook_accel_map_set_reload		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_reload		(GLookAccelMap *map);
void		glook_accel_map_set_zoom_in		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_zoom_in		(GLookAccelMap *map);
void		glook_accel_map_set_zoom_out		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_zoom_out		(GLookAccelMap *map);
void		glook_accel_map_set_zoom_100		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_zoom_100		(GLookAccelMap *map);
void		glook_accel_map_set_writable		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_writable		(GLookAccelMap *map);
void		glook_accel_map_set_save_screen		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_save_screen		(GLookAccelMap *map);
void		glook_accel_map_set_suspension		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_suspension		(GLookAccelMap *map);
void		glook_accel_map_set_disconnect		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_disconnect		(GLookAccelMap *map);
void		glook_accel_map_set_close_tab		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_close_tab		(GLookAccelMap *map);
void		glook_accel_map_set_tab_1		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_1		(GLookAccelMap *map);
void		glook_accel_map_set_tab_2		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_2		(GLookAccelMap *map);
void		glook_accel_map_set_tab_3		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_3		(GLookAccelMap *map);
void		glook_accel_map_set_tab_4		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_4		(GLookAccelMap *map);
void		glook_accel_map_set_tab_5		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_5		(GLookAccelMap *map);
void		glook_accel_map_set_tab_6		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_6		(GLookAccelMap *map);
void		glook_accel_map_set_tab_7		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_7		(GLookAccelMap *map);
void		glook_accel_map_set_tab_8		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_8		(GLookAccelMap *map);
void		glook_accel_map_set_tab_9		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_tab_9		(GLookAccelMap *map);
void		glook_accel_map_set_left_tab		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_left_tab		(GLookAccelMap *map);
void		glook_accel_map_set_right_tab		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_right_tab		(GLookAccelMap *map);
void		glook_accel_map_set_get_start		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_get_start		(GLookAccelMap *map);
void		glook_accel_map_set_resources		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_resources		(GLookAccelMap *map);
void		glook_accel_map_set_address_bar		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_address_bar		(GLookAccelMap *map);
void		glook_accel_map_set_playback		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_playback		(GLookAccelMap *map);
void		glook_accel_map_set_forward		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_forward		(GLookAccelMap *map);
void		glook_accel_map_set_backward		(GLookAccelMap *map,
							 const gchar   *accelerator);
gchar*		glook_accel_map_get_backward		(GLookAccelMap *map);

G_END_DECLS

#endif /* __GLOOK_ACCEL_MAP_H__ */
