/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_ACTIONS_H__
#define __GLOOK_ACTIONS_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

void	on_app_open_agent_tab_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_address_bar_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_new_tab_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_new_window_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	glook_open_record_file		(GLookWindow     *window);
void	on_app_play_file_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_play_recent_activated	(GtkRecentChooser *chooser,
					 GLookWindow      *window);
#ifdef G_OS_UNIX
void	on_app_open_terminal_activated	(GtkAction        *action,
					 GLookWindow      *window);
#endif
void	on_app_show_control_toggled	(GtkToggleAction *action,
					 GLookWindow     *window);
void	on_app_bookmarks_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_preference_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_log_activated		(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_close_window_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_app_quit_activated		(GtkAction       *action,
					 GLookWindow     *window);

void	on_tab_copy_activated		(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_paste_activated		(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_select_all_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_close_tab_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_zoom_in_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_zoom_out_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_zoom_100_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_reload_activated		(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_switch_activated		(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_switch_left_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_tab_switch_right_activated	(GtkAction       *action,
					 GLookWindow     *window);

void	on_help_getstart_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_ttyrcd_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_ttyagent_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_ttylook_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_ttyplay_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_online_activated	(GtkAction       *action,
					 GLookWindow     *window);
void	on_help_about_activated		(GtkAction       *action,
					 GLookWindow     *window);

void	on_window_toolbar_zoom		(GtkWidget       *toolbar,
					 gint             factor,
					 GLookWindow     *window);
void	on_window_addrbar_erase		(GtkEntry        *addrbar,
					 GLookWindow     *window);
void	on_window_addrbar_go		(GtkEntry        *addrbar,
					 const gchar     *address,
					 GLookWindow     *window);
void	on_window_addrbar_stop		(GtkEntry        *addrbar,
					 GLookWindow     *window);
void	on_window_addrbar_bookmark	(GtkEntry        *addrbar,
					 gint             button,
					 GLookWindow     *window);

void	on_window_notebook_page_added	(GtkNotebook     *notebook,
					 GtkWidget       *child,
					 guint            page_num,
					 GLookWindow     *window);
void	on_window_notebook_page_removed	(GtkNotebook     *notebook,
					 GtkWidget       *child,
					 guint            page_num,
					 GLookWindow     *window);
void	on_window_notebook_page_switched(GtkNotebook     *notebook,
					 GtkNotebookPage *page,
					 guint            page_num,
					 GLookWindow     *window);

G_END_DECLS

#endif /* __GLOOK_ACTIONS_H__ */
