/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_APP_H__
#define __GLOOK_APP_H__

#include <gtk/gtk.h>
#include "glook-bookmark.h"

G_BEGIN_DECLS

#define GLOOK_TYPE_APP			(glook_app_get_type ())
#define GLOOK_APP(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_APP, GLookApp))
#define GLOOK_APP_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_APP, GLookAppClass))
#define GLOOK_IS_APP(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_APP))
#define GLOOK_IS_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_APP))
#define GLOOK_APP_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_APP, GLookAppClass))

typedef struct _GLookApp	GLookApp;
typedef struct _GLookAppClass	GLookAppClass;
typedef struct _GLookAppPriv	GLookAppPriv;

struct _GLookApp
{
  GObject parent;
  GLookAppPriv *priv;
};

struct _GLookAppClass
{
  GObjectClass parent_class;
};

typedef enum
{
  SETTINGS_GENERAL,
  SETTINGS_AGENTTAB,
  SETTINGS_ACCELERATOR,
  SETTINGS_TERMINAL,
  SETTINGS_PROFILE1,
  SETTINGS_PROFILE2,
  SETTINGS_PROFILE3,
  SETTINGS_PROFILE4,
  SETTINGS_PROFILE5,
  N_SETTINGS
} GLookAppSettings;

GType		glook_app_get_type		(void) G_GNUC_CONST;

GLookApp*	glook_app_new			(void);
GLookApp*	glook_app_get			(void);

GtkWindowGroup*	glook_app_get_window_group	(GLookApp         *app);

GLookBookmark*	glook_app_get_bookmark		(GLookApp         *app);
GSettings*	glook_app_get_settings		(GLookApp         *app,
						 GLookAppSettings  settings);
GSettings*	glook_app_get_profile_settings	(GLookApp         *app,
						 const gchar      *profile);

void		glook_app_run			(GLookApp         *app);
void		glook_app_quit			(GLookApp         *app);

GtkWidget*	glook_app_create_window		(GLookApp         *app,
						 gboolean          with_blank_tab);
GdkRectangle*	glook_app_get_workarea		(GLookApp         *app);

void		glook_app_set_accelerators	(GLookApp         *app);

G_END_DECLS

#endif /* __GLOOK_APP_H__ */
