/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <glib/gi18n.h>

#include "glook-tab.h"
#include "glook-blank-tab.h"


struct _GLookBlankTabPriv
{
  GtkWidget *treeview;
};
#define _BLANK_TAB_GET_PRIVATE(o)	(G_TYPE_INSTANCE_GET_PRIVATE ((o), GLOOK_TYPE_BLANK_TAB, GLookBlankTabPriv))

G_DEFINE_TYPE (GLookBlankTab, glook_blank_tab, GLOOK_TYPE_TAB);

/**
 * glook_blank_tab_init:
 */
static void
glook_blank_tab_init (GLookBlankTab *tab)
{
  g_object_set (tab, "stock", GTK_STOCK_FILE, "label", _("Blank"), NULL);

  tab->priv = _BLANK_TAB_GET_PRIVATE (tab);

  tab->priv->treeview = gtk_tree_view_new ();
  g_object_set (tab->priv->treeview, "can-focus", FALSE, NULL);

  gtk_container_add (GTK_CONTAINER (tab), tab->priv->treeview);

  gtk_widget_show_all (GTK_WIDGET (tab));
}

/**
 * glook_blank_tab_dispose:
 */
static void
glook_blank_tab_dispose (GObject *object)
{
#if 0
  GLookBlankTab *tab = GLOOK_BLANK_TAB (object);
#endif

  G_OBJECT_CLASS (glook_blank_tab_parent_class)->dispose (object);
}

/**
 * glook_blank_tab_finalize:
 */
static void
glook_blank_tab_finalize (GObject *object)
{
#if 0
  GLookBlankTab *blank_tab = GLOOK_BLANK_TAB (object);
#endif

  G_OBJECT_CLASS (glook_blank_tab_parent_class)->finalize (object);
}

/**
 * glook_blank_tab_class_init:
 */
static void
glook_blank_tab_class_init (GLookBlankTabClass *klass)
{
  GObjectClass *gobject_class = G_OBJECT_CLASS (klass);

  g_type_class_add_private (klass, sizeof (GLookBlankTabPriv));

  gobject_class->dispose  = glook_blank_tab_dispose;
  gobject_class->finalize = glook_blank_tab_finalize;
}

/**
 * glook_blank_tab_new:
 */
GtkWidget*
glook_blank_tab_new (void)
{
  return g_object_new (GLOOK_TYPE_BLANK_TAB, NULL);
}

/**
 * glook_blank_tab_set_uri:
 */
void
glook_blank_tab_set_uri (GLookBlankTab *tab)
{
  GLookUri *uri;

  g_return_if_fail (GLOOK_IS_BLANK_TAB (tab));

  uri = glook_uri_new ();
  glook_uri_set_scheme_type (uri, GLOOK_URI_SCHEME_BLANK);

  glook_tab_set_uri (GLOOK_TAB (tab), uri);
}
