/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_BOOKMARK_H__
#define __GLOOK_BOOKMARK_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_BOOKMARK		(glook_bookmark_get_type ())
#define GLOOK_BOOKMARK(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_BOOKMARK, GLookBookmark))
#define GLOOK_BOOKMARK_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_BOOKMARK, GLookBookmarkClass))
#define GLOOK_IS_BOOKMARK(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_BOOKMARK))
#define GLOOK_IS_BOOKMARK_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_BOOKMARK))
#define GLOOK_BOOKMARK_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_BOOKMARK, GLookBookmarkClass))

typedef struct _GLookBookmark		GLookBookmark;
typedef struct _GLookBookmarkClass	GLookBookmarkClass;
typedef struct _GLookBookmarkPriv	GLookBookmarkPriv;

struct _GLookBookmark
{
  GObject parent;
  GLookBookmarkPriv *priv;
};

struct _GLookBookmarkClass
{
  GtkDialogClass parent_class;
};

GType		glook_bookmark_get_type		(void) G_GNUC_CONST;

GLookBookmark*	glook_bookmark_new		(void);

GBookmarkFile*	glook_bookmark_get_file		(GLookBookmark *bookmark);

const gchar*	glook_bookmark_get_path		(GLookBookmark *bookmark);
void		glook_bookmark_set_path		(GLookBookmark *bookmark,
						 const gchar   *path);

gboolean	glook_bookmark_add		(GLookBookmark *bookmark,
						 const gchar   *address,
						 const gchar   *title,
						 const gchar   *desc);
gboolean	glook_bookmark_remove		(GLookBookmark *bookmark,
						 const gchar   *address);
gboolean	glook_bookmark_has		(GLookBookmark *bookmark,
						 const gchar   *address);
void		glook_bookmark_update_visited	(GLookBookmark *bookmark,
						 const gchar   *address);

gboolean	glook_bookmark_save_to_file	(GLookBookmark *bookmark,
						 const gchar   *pathname);
gboolean	glook_bookmark_add_from_file	(GLookBookmark *bookmark,
						 const gchar   *pathname);

G_END_DECLS

#endif /* __GLOOK_BOOKMARK_H__ */
