/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_COMPLETION_H__
#define __GLOOK_COMPLETION_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_COMPLETION			(glook_completion_get_type ())
#define GLOOK_COMPLETION(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_COMPLETION, GLookCompletion))
#define GLOOK_COMPLETION_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_COMPLETION, GLookCompletionClass))
#define GLOOK_IS_COMPLETION(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_COMPLETION))
#define GLOOK_IS_COMPLETION_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_COMPLETION))
#define GLOOK_COMPLETION_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_COMPLETION, GLookCompletionClass))

typedef struct _GLookCompletion		GLookCompletion;
typedef struct _GLookCompletionClass	GLookCompletionClass;
typedef struct _GLookCompletionPriv	GLookCompletionPriv;

struct _GLookCompletion
{
  GtkEntryCompletion   parent;
  GLookCompletionPriv *priv;
};

struct _GLookCompletionClass
{
  GtkEntryCompletionClass parent_class;
};

GType		glook_completion_get_type	(void) G_GNUC_CONST;

GLookCompletion* glook_completion_new		(void);

void		glook_completion_insert		(GLookCompletion *completion,
						 const gchar     *icon_name,
						 const gchar     *uri,
						 const gchar     *title,
						 time_t           time_,
						 gboolean         replace);
void		glook_completion_remove		(GLookCompletion *completion,
						 const gchar     *uri);
void		glook_completion_clear		(GLookCompletion *completion);

G_END_DECLS

#endif /* __GLOOK_COMPLETION_H__ */
