/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_NOTEBOOK_H__
#define __GLOOK_NOTEBOOK_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_NOTEBOOK		(glook_notebook_get_type ())
#define GLOOK_NOTEBOOK(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_NOTEBOOK, GLookNotebook))
#define GLOOK_NOTEBOOK_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_NOTEBOOK, GLookNotebookClass))
#define GLOOK_IS_NOTEBOOK(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_NOTEBOOK))
#define GLOOK_IS_NOTEBOOK_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_NOTEBOOK))
#define GLOOK_NOTEBOOK_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_NOTEBOOK, GLookNotebookClass))

typedef struct _GLookNotebook		GLookNotebook;
typedef struct _GLookNotebookClass	GLookNotebookClass;
typedef struct _GLookNotebookPriv	GLookNotebookPriv;

struct _GLookNotebook
{
  GtkNotebook parent;
  GLookNotebookPriv *priv;
};

struct _GLookNotebookClass
{
  GtkNotebookClass parent_class;
};

GType		glook_notebook_get_type		(void) G_GNUC_CONST;

GtkWidget*	glook_notebook_new		(void);

void		glook_notebook_append		(GLookNotebook *notebook,
						 GtkWidget     *tab);
void		glook_notebook_insert		(GLookNotebook *notebook,
						 GtkWidget     *tab,
						 gint           n);
void		glook_notebook_remove		(GLookNotebook *notebook,
						 GtkWidget     *tab);
void		glook_notebook_remove_n		(GLookNotebook *notebook,
						 gint           n);
void		glook_notebook_remove_others	(GLookNotebook *notebook,
						 GtkWidget     *tab);
void		glook_notebook_remove_current	(GLookNotebook *notebook);
GtkWidget*	glook_notebook_get_current	(GLookNotebook *notebook);
void		glook_notebook_set_current	(GLookNotebook *notebook,
						 GtkWidget     *tab);
void		glook_notebook_set_current_n	(GLookNotebook *notebook,
						 gint           n);
gboolean	glook_notebook_is_current	(GLookNotebook *notebook,
						 GtkWidget     *tab);
gint		glook_notebook_get_nth		(GLookNotebook *notebook,
						 GtkWidget     *tab);
void		glook_notebook_replace		(GLookNotebook *notebook,
						 GtkWidget     *tab);

G_END_DECLS

#endif /* __GLOOK_NOTEBOOK_H__ */
