/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_PROFILE_DIALOG_H__
#define __GLOOK_PROFILE_DIALOG_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_PROFILE_DIALOG		(glook_profile_dialog_get_type ())
#define GLOOK_PROFILE_DIALOG(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_PROFILE_DIALOG, GLookProfileDialog))
#define GLOOK_PROFILE_DIALOG_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_PROFILE_DIALOG, GLookProfileDialogClass))
#define GLOOK_IS_PROFILE_DIALOG(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_PROFILE_DIALOG))
#define GLOOK_IS_PROFILE_DIALOG_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_PROFILE_DIALOG))
#define GLOOK_PROFILE_DIALOG_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_PROFILE_DIALOG, GLookProfileDialogClass))

typedef struct _GLookProfileDialog	GLookProfileDialog;
typedef struct _GLookProfileDialogClass	GLookProfileDialogClass;
typedef struct _GLookProfileDialogPriv	GLookProfileDialogPriv;

struct _GLookProfileDialog
{
  GtkDialog parent;
  GLookProfileDialogPriv *priv;
};

struct _GLookProfileDialogClass
{
  GtkDialogClass parent_class;
};

enum
{
  BACKGROUND_EFFECT_NONE  = 0,
  BACKGROUND_EFFECT_IMAGE = 1,
  BACKGROUND_EFFECT_TRANSPARENT = 2,
};

GType		glook_profile_dialog_get_type		(void) G_GNUC_CONST;

GtkWidget*	glook_profile_dialog_new		(void);

void		glook_profile_dialog_set_profile	(GLookProfileDialog *dialog,
							 const gchar        *profile,
							 GSettings          *settings);
const gchar*	glook_profile_dialog_get_profile	(GLookProfileDialog *dialog);

#endif /* __GLOOK_PROFILE_DIALOG_H__ */
