/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_TAB_H__
#define __GLOOK_TAB_H__

#include <gtk/gtk.h>
#include "glook-uri.h"

G_BEGIN_DECLS

#define GLOOK_TYPE_TAB			(glook_tab_get_type ())
#define GLOOK_TAB(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_TAB, GLookTab))
#define GLOOK_TAB_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_TAB, GLookTabClass))
#define GLOOK_IS_TAB(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_TAB))
#define GLOOK_IS_TAB_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_TAB))
#define GLOOK_TAB_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_TAB, GLookTabClass))

#define GLOOK_TAB_ZOOM_SUPPORT(tab)	(GLOOK_TAB_GET_CLASS (tab)->zoom ? TRUE : FALSE)
#define GLOOK_TAB_REFRESH_SUPPORT(tab)	(GLOOK_TAB_GET_CLASS (tab)->reload ? TRUE : FALSE)
#define GLOOK_TAB_FIND_SUPPORT(tab)	(GLOOK_TAB_GET_CLASS (tab)->find ? TRUE : FALSE)

typedef struct _GLookTab	GLookTab;
typedef struct _GLookTabClass	GLookTabClass;
typedef struct _GLookTabPriv	GLookTabPriv;

struct _GLookTab
{
  GtkVBox parent;

  /*< private >*/
  GLookUri  *uri;
  GtkWidget *tab_head;
  GtkWidget *menu;
  gboolean   progress;
  gint       zoom_index;
};

struct _GLookTabClass
{
  GtkVBoxClass parent_class;

  /* signal handler */
  void		(*progress)	(GLookTab *tab);
  void		(*finished)	(GLookTab *tab);

  /* virtial method */
  void		(*merge_ui)	(GLookTab  *tab,
				 GtkWidget *window);
  void		(*unmerge_ui)	(GLookTab  *tab,
				 GtkWidget *window);
  void		(*open)		(GLookTab  *tab);
  void		(*stop)		(GLookTab  *tab);
  gboolean	(*is_active)	(GLookTab  *tab);
  gboolean	(*zoom)		(GLookTab  *tab,
				 gint       factor);
  void		(*reload)	(GLookTab  *tab);
  void		(*find)		(GLookTab  *tab);
  void		(*geometry_hint)(GLookTab  *tab);
};

gint		glook_tab_get_zoom_100_index	(void);

GType		glook_tab_get_type		(void) G_GNUC_CONST;

GtkWidget*	glook_tab_get_tab_head		(GLookTab    *tab);

const gchar*	glook_tab_get_label		(GLookTab    *tab);
const gchar*	glook_tab_get_label_text	(GLookTab    *tab);
void		glook_tab_set_label		(GLookTab    *tab,
						 const gchar *string);
const gchar*	glook_tab_get_image		(GLookTab    *tab);
void		glook_tab_set_image		(GLookTab    *tab,
						 const gchar *icon_name);
const gchar*	glook_tab_get_stock		(GLookTab    *tab);
void		glook_tab_set_stock		(GLookTab    *tab,
						 const gchar *stock);
void		glook_tab_set_image_visible	(GLookTab    *tab,
						 gboolean     visible);
void		glook_tab_set_spinner_visible	(GLookTab    *tab,
						 gboolean     visible);
GLookUri*	glook_tab_get_uri		(GLookTab    *tab);
void		glook_tab_set_uri		(GLookTab    *tab,
						 GLookUri    *uri);
gboolean	glook_tab_get_progress		(GLookTab    *tab);
void		glook_tab_set_progress		(GLookTab    *tab,
						 gboolean     progress);
gint		glook_tab_get_zoom_index	(GLookTab    *tab);
gint		glook_tab_get_zoom_factor	(GLookTab    *tab);

void		glook_tab_close			(GLookTab    *tab);

void		glook_tab_merge_ui		(GLookTab    *tab,
						 GtkWidget   *window);
void		glook_tab_unmerge_ui		(GLookTab    *tab,
						 GtkWidget   *window);
void		glook_tab_open			(GLookTab    *tab);
void		glook_tab_stop			(GLookTab    *tab);
gboolean	glook_tab_is_active		(GLookTab    *tab);
gboolean	glook_tab_zoom			(GLookTab    *tab,
						 gint         index);
void		glook_tab_reload		(GLookTab    *tab);
void		glook_tab_find			(GLookTab    *tab);
void		glook_tab_geometry_hint		(GLookTab    *tab);

G_END_DECLS

#endif /* __GLOOK_TAB_H__ */
