/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_TERMINAL_H__
#define __GLOOK_TERMINAL_H__

#include <gtk/gtk.h>
#include <vte/vte.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_TERMINAL		(glook_terminal_get_type ())
#define GLOOK_TERMINAL(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_TERMINAL, GLookTerminal))
#define GLOOK_TERMINAL_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_TERMINAL, GLookTerminalClass))
#define GLOOK_IS_TERMINAL(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_TERMINAL))
#define GLOOK_IS_TERMINAL_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_TERMINAL))
#define GLOOK_TERMINAL_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_TERMINAL, GLookTerminalClass))

typedef struct _GLookTerminal		GLookTerminal;
typedef struct _GLookTerminalClass	GLookTerminalClass;
typedef struct _GLookTerminalPriv	GLookTerminalPriv;
typedef struct _GLookTerminalPopupInfo	GLookTerminalPopupInfo;

typedef enum
{
  TERMINAL_URI_TYPE_UNKNOWN,	/* ???. */
  TERMINAL_URI_TYPE_URI,	/* general uri. */
  TERMINAL_URI_TYPE_WEB,	/* open with web browser. */
  TERMINAL_URI_TYPE_MAIL,	/* open with email client. */
  TERMINAL_URI_TYPE_CALL,	/* open with voip client. */
} GLookTerminalUriType;

struct _GLookTerminal
{
  VteTerminal parent;
  GLookTerminalPriv *priv;
};

struct _GLookTerminalClass
{
  VteTerminalClass parent_class;

  /* signal handler. */
  gboolean	(*uri_clicked)	(GLookTerminal *terminal,
				 const gchar   *address,
				 gint           uri_type,
				 guint          modified);
};

struct _GLookTerminalPopupInfo
{
  gint                 refcount;
  GtkWidget           *terminal;
  gchar               *address;
  GLookTerminalUriType uri_type;
  guint                button;
  guint                modified;
  guint32              timestamp;
};

GLookTerminalPopupInfo*
		glook_terminal_popup_info_ref		(GLookTerminalPopupInfo *info);
void		glook_terminal_popup_info_unref 	(GLookTerminalPopupInfo *info);

GType		glook_terminal_get_type			(void) G_GNUC_CONST;

GtkWidget*	glook_terminal_new			(void);

void		glook_terminal_set_profile		(GLookTerminal *terminal,
							 const gchar   *profile);
const gchar*	glook_terminal_get_profile		(GLookTerminal *terminal);

GLookTerminalPopupInfo*
		glook_terminal_get_popup_info		(GLookTerminal *terminal);

void		glook_terminal_save_screen		(GLookTerminal *terminal,
							 const gchar   *filename,
							 gint           range,
							 gint           format,
							 gboolean       break_line);
void		glook_terminal_save_screen_dialog	(GLookTerminal *terminal,
							 GtkWidget     *window);

void		glook_terminal_show_not_found		(GLookTerminal *terminal,
							 const gchar   *address);
void		glook_terminal_show_hangup		(GLookTerminal *terminal);
void		glook_terminal_show_play_over		(GLookTerminal *terminal,
							 gdouble        elapsed);

void		glook_terminal_zoom			(GLookTerminal *terminal,
							 gint           factor);
void		glook_terminal_get_size			(GLookTerminal *terminal,
							 glong         *cols,
							 glong         *rows);
void		glook_terminal_get_char_size		(GLookTerminal *terminal,
							 glong         *char_width,
							 glong         *char_height);

G_END_DECLS

#endif /* __GLOOK_TERMINAL_H__ */
