/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_TOOLBAR_H__
#define __GLOOK_TOOLBAR_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_TOOLBAR		(glook_toolbar_get_type ())
#define GLOOK_TOOLBAR(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_TOOLBAR, GLookToolbar))
#define GLOOK_TOOLBAR_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_TOOLBAR, GLookToolbarClass))
#define GLOOK_IS_TOOLBAR(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_TOOLBAR))
#define GLOOK_IS_TOOLBAR_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_TOOLBAR))
#define GLOOK_TOOLBAR_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_TOOLBAR, GLookToolbarClass))

typedef struct _GLookToolbar		GLookToolbar;
typedef struct _GLookToolbarClass	GLookToolbarClass;
typedef struct _GLookToolbarPriv	GLookToolbarPriv;

struct _GLookToolbar
{
  GtkToolbar parent;
  GLookToolbarPriv *priv;
};

struct _GLookToolbarClass
{
  GtkToolbarClass parent_class;

  void	(*zoom)	(GLookToolbar *toolbar,
		 gint          factor);
};

GType		glook_toolbar_get_type		(void) G_GNUC_CONST;

GtkWidget*	glook_toolbar_new		(GtkWidget    *window);

GtkWidget*	glook_toolbar_get_addrbar	(GLookToolbar *toolbar);
GtkWidget*	glook_toolbar_get_zoom_combo	(GLookToolbar *toolbar);

void		glook_toolbar_zoom_in		(GLookToolbar *toolbar);
void		glook_toolbar_zoom_out		(GLookToolbar *toolbar);
void		glook_toolbar_zoom_100		(GLookToolbar *toolbar);

G_END_DECLS

#endif /* __GLOOK_TOOLBAR_H__ */
