/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_UI_H__
#define __GLOOK_UI_H__

#include <gtk/gtk.h>

G_BEGIN_DECLS

#define GLOOK_TYPE_UI			(glook_ui_get_type ())
#define GLOOK_UI(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_UI, GLookUi))
#define GLOOK_UI_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_UI, GLookUiClass))
#define GLOOK_IS_UI(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_UI))
#define GLOOK_IS_UI_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_UI))
#define GLOOK_UI_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_UI, GLookUiClass))

#define STATUSBAR_CONTEXT_TOOLTIP	1
#define STATUSBAR_CONTEXT_MESSAGE	2

typedef struct _GLookUi		GLookUi;
typedef struct _GLookUiClass	GLookUiClass;
typedef struct _GLookUiPriv	GLookUiPriv;

struct _GLookUi
{
  GtkUIManager  parent;
  GLookUiPriv  *priv;
};

struct _GLookUiClass
{
  GtkUIManagerClass parent_class;
};

GType		glook_ui_get_type		(void) G_GNUC_CONST;

GLookUi*	glook_ui_new			(GtkWidget      *window);

GtkWidget*	glook_ui_get_menubar		(GLookUi        *ui);
GtkAction*	glook_ui_get_window_action	(GLookUi        *ui,
						 const gchar    *name);
gint		glook_ui_merge			(GLookUi        *ui,
						 GtkActionGroup *action_group,
						 const gchar    *string,
						 gint            length);
void		glook_ui_unmerge		(GLookUi        *ui,
						 guint           merge_id);
guint		glook_get_merge_id		(GLookUi        *ui,
						 GtkActionGroup *action_group);

G_END_DECLS

#endif /* __GLOOK_UI_H__ */
