/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_URI_H__
#define __GLOOK_URI_H__

#include <gtk/gtk.h>
#include <gio/gio.h>

G_BEGIN_DECLS

typedef struct _GLookUri	GLookUri;

typedef enum
{
  GLOOK_URI_SCHEME_UNKNOWN,
  GLOOK_URI_SCHEME_BLANK,
  GLOOK_URI_SCHEME_AGENT,
  GLOOK_URI_SCHEME_LOOK,
  GLOOK_URI_SCHEME_PLAY,
#ifdef G_OS_UNIX
  GLOOK_URI_SCHEME_TERMINAL,
#endif
  GLOOK_URI_SCHEME_LOCAL,
} GLookUriScheme;

GLookUriScheme	glook_uri_scheme_name_to_type	(const gchar    *scheme);
const gchar*	glook_uri_scheme_name_from_type	(GLookUriScheme  scheme_type);
gboolean	glook_uri_scheme_name_support	(const gchar    *scheme);

GLookUri*	glook_uri_new			(void);
GLookUri*	glook_uri_new_from_string	(const gchar    *string);
void		glook_uri_free			(GLookUri       *uri);
GLookUri*	glook_uri_ref			(GLookUri       *uri);
void		glook_uri_unref			(GLookUri       *uri);

gchar*		glook_uri_to_string		(GLookUri       *uri);

GHashTable*	glook_uri_get_attrs_table	(GLookUri       *uri);

void		glook_uri_set_scheme		(GLookUri       *uri,
						 const gchar    *scheme);
void		glook_uri_set_scheme_type	(GLookUri       *uri,
						 GLookUriScheme  scheme_type);
const gchar*	glook_uri_get_scheme		(GLookUri       *uri);
GLookUriScheme	glook_uri_get_scheme_type	(GLookUri       *uri);

void		glook_uri_insert_attr		(GLookUri       *uri,
						 const gchar    *key,
						 const gchar    *value);
void		glook_uri_remove_attr		(GLookUri       *uri,
						 const gchar    *key);
const gchar*	glook_uri_lookup_attr		(GLookUri       *uri,
						 const gchar    *key);

gboolean	glook_uri_is_equal		(GLookUri       *uri1,
						 GLookUri       *uri2);

gchar*		glook_uri_get_dbus_address	(GLookUri       *uri,
						 GBusType       *bus_type);

G_END_DECLS

#endif /* __GLOOK_URI_H__ */
