/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __GLOOK_WINDOW_H__
#define __GLOOK_WINDOW_H__

#include <gtk/gtk.h>
#include "glook-uri.h"

G_BEGIN_DECLS

#define GLOOK_TYPE_WINDOW		(glook_window_get_type ())
#define GLOOK_WINDOW(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), GLOOK_TYPE_WINDOW, GLookWindow))
#define GLOOK_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), GLOOK_TYPE_WINDOW, GLookWindowClass))
#define GLOOK_IS_WINDOW(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), GLOOK_TYPE_WINDOW))
#define GLOOK_IS_WINDOW_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), GLOOK_TYPE_WINDOW))
#define GLOOK_WINDOW_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), GLOOK_TYPE_WINDOW, GLookWindowClass))

typedef struct _GLookWindow		GLookWindow;
typedef struct _GLookWindowClass	GLookWindowClass;
typedef struct _GLookWindowPriv		GLookWindowPriv;

struct _GLookWindow
{
  GtkWindow parent;
  GLookWindowPriv *priv;
};

struct _GLookWindowClass
{
  GtkWindowClass parent_class;
};

GType		glook_window_get_type			(void) G_GNUC_CONST;

GtkWidget*	glook_window_new			(void);

void		glook_window_delete			(GLookWindow    *window);

gboolean	glook_window_get_rgba_colormap		(GLookWindow    *window);
GtkUIManager*	glook_window_get_uiman			(GLookWindow    *window);
GtkWidget*	glook_window_get_menubar		(GLookWindow    *window);
GtkWidget*	glook_window_get_toolbar		(GLookWindow    *window);
GtkWidget*	glook_window_get_addrbar		(GLookWindow    *window);
GtkWidget*	glook_window_get_zoom_combo		(GLookWindow    *window);
GtkWidget*	glook_window_get_notebook		(GLookWindow    *window);
GtkWidget*	glook_window_get_statusbar		(GLookWindow    *window);

gint		glook_window_merge_ui			(GLookWindow    *window,
							 GtkActionGroup *action_group,
							 GtkAccelGroup  *accel_group,
							 const gchar    *string,
							 gint            length);
void		glook_window_unmerge_ui			(GLookWindow    *window,
							 GtkAccelGroup  *accel_group,
							 guint           merge_id);

GtkWidget*	glook_window_open_uri_string		(GLookWindow    *window,
							 const gchar    *string);
gboolean	glook_window_get_frame_extents		(GLookWindow    *window,
							 GdkRectangle   *rect);
void		glook_window_add_tab			(GLookWindow    *window,
							 GtkWidget      *tab,
							 gboolean        become_current);
GtkWidget*	glook_window_add_blank_tab		(GLookWindow    *window,
							 gboolean        become_current);

G_END_DECLS

#endif /* __GLOOK_WINDOW_H__ */
