/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __LOOK_APP_H__
#define __LOOK_APP_H__

#include <glib.h>
#include <glib-object.h>

G_BEGIN_DECLS

#define LOOK_TYPE_APP			(look_app_get_type ())
#define LOOK_APP(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), LOOK_TYPE_APP, LookApp))
#define LOOK_APP_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), LOOK_TYPE_APP, LookAppClass))
#define LOOK_IS_APP(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), LOOK_TYPE_APP))
#define LOOK_IS_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), LOOK_TYPE_APP))
#define LOOK_APP_GET_CLASS(obj)		(G_TYPE_INSTANCE_GET_CLASS ((obj), LOOK_TYPE_APP, LookAppClass))

typedef struct _LookApp		LookApp;
typedef struct _LookAppClass	LookAppClass;
typedef struct _LookAppPrivate	LookAppPrivate;

struct _LookApp
{
  GObject         parent;
  LookAppPrivate *priv;
};

struct _LookAppClass
{
  GObjectClass parent;
};

GType		look_app_get_type		(void);

LookApp*	look_app_new			(void);
LookApp*	look_app_get			(void);

void		look_app_set_server_address	(LookApp        *app,
						 const gchar    *host);
void		look_app_set_writable		(LookApp        *app,
						 gboolean        writable);
void		look_app_set_quit_key		(LookApp        *app,
						 gchar           key);
TLook*		look_app_get_look		(LookApp        *app);
TConsole*	look_app_get_console		(LookApp        *app);
GCancellable*	look_app_get_agent_cancellable	(LookApp        *app);

void		look_app_start			(LookApp        *app);
void		look_app_quit			(LookApp        *app);

G_END_DECLS

#endif /* __LOOK_APP_H__ */
