-- Copyright (c) 2010 Lodes Network Inc.
-- Written by: xiaohu <xiaohu417@gmail.com>
--
require "_ttyutils"


--------------------------------------------------------
-- modify LUA_PATH
--------------------------------------------------------
function luapath_add (path, append)
	local append = append or true
	local path2 = string.format ("%s/?;%s/?.lua;%s/?.luc", path, path, path)
	local env = os.getenv ("LUA_PATH")
	if env then
		if append then
			path2 = env .. ";" .. path2
		else
			path2 = path2 .. ";" .. env
		end
	end
	system.setenv ("LUA_PATH", path2, true)
end

--------------------------------------------------------
-- add user local module path
--------------------------------------------------------
if os.getenv ("HOME") then
	luapath_add (os.getenv ("HOME") .. "/.ttyutils3/lua")
end

--------------------------------------------------------
-- gettext support
--------------------------------------------------------
bindtextdomain = gettext.bindtextdomain
tr = gettext.translate

--------------------------------------------------------
-- Ctrl(x) constants
--------------------------------------------------------
CTRL =
{
	a = 1,  b = 2,  c = 3,  d = 4,  e = 5,  f = 6,  g = 7,  h = 8,
	i = 9,  j = 10, k = 11, l = 12, m = 13, n = 14, o = 15, p = 16,
	q = 17, r = 18, s = 19, t = 20, u = 21, v = 22, w = 23, x = 24,
	y = 25, z = 26,
	A = 1,  B = 2,  C = 3,  D = 4,  E = 5,  F = 6,  G = 7,  H = 8,
	I = 9,  J = 10, K = 11, L = 12, M = 13, N = 14, O = 15, P = 16,
	Q = 17, R = 18, S = 19, T = 20, U = 21, V = 22, W = 23, X = 24,
	Y = 25, Z = 26,
}
