/* Copyright (c) 2010 Lodes Network Inc.
 * Written by: xiaohu <xiaohu417@gmail.com>
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

#include <glib.h>

/** log_print:
 */
static gint
lua_log_print (lua_State *L)
{
  g_print ("%s", luaL_checkstring (L, 1));
  return 0;
}

/** log_println:
 */
static gint
lua_log_println (lua_State *L)
{
  g_print ("%s\n", luaL_checkstring (L, 1));
  return 0;
}

/** log_debug:
 */
static gint
lua_log_debug (lua_State *L)
{
  g_debug ("%s", luaL_checkstring (L, 1));
  return 0;
}

/** log_msg:
 */
static gint
lua_log_msg (lua_State *L)
{
  g_message ("%s", luaL_checkstring (L, 1));
  return 0;
}

/** log_warn:
 */
static gint
lua_log_warn (lua_State *L)
{
  g_warning ("%s", luaL_checkstring (L, 1));
  return 0;
}

/** log_crit:
 */
static gint
lua_log_crit (lua_State *L)
{
  g_critical ("%s", luaL_checkstring (L, 1));
  return 0;
}

/** log_error:
 */
static gint
lua_log_error (lua_State *L)
{
  g_error ("%s", luaL_checkstring (L, 1));
  return 0;
}

luaL_Reg _lua_log[] =
{
    { "print",		lua_log_print	},
    { "println",	lua_log_println	},
    { "debug",		lua_log_debug	},
    { "msg",		lua_log_msg	},
    { "warn",		lua_log_warn	},
    { "crit",		lua_log_crit	},
    { "error",		lua_log_error	},

    { NULL, NULL }
};
