/* Copyright (c) 2010 Lodes Network Inc.
 * Written by: xiaohu <xiaohu417@gmail.com>
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <lua.h>
#include <lualib.h>
#include <lauxlib.h>

#include <unistd.h>
#include <glib.h>

/**
 * system_sleep:
 */
gint
lua_system_sleep (lua_State *L)
{
  sleep (luaL_checkint (L, 1));
  return 0;
}

/**
 * system_usleep:
 */
gint
lua_system_usleep (lua_State *L)
{
  g_usleep (luaL_checkint (L, 1));
  return 0;
}

/**
 * lua_system_setenv:
 */
gint
lua_system_setenv (lua_State *L)
{
  const gchar *name = luaL_checkstring (L, 1);
  const gchar *value = luaL_checkstring (L, 2);
  gboolean overwrite = lua_toboolean (L, 3);
  g_setenv (name, value, overwrite);
  return 0;
}

luaL_Reg _lua_system[] =
{
    { "sleep",		lua_system_sleep	},
    { "usleep",		lua_system_usleep	},
    { "setenv",		lua_system_setenv	},

    { NULL, NULL }
};
