/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __RECORD_AGENT_H__
#define __RECORD_AGENT_H__

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define RECORD_TYPE_AGENT		(record_agent_get_type ())
#define RECORD_AGENT(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), RECORD_TYPE_AGENT, RecordAgent))
#define RECORD_AGENT_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), RECORD_TYPE_AGENT, RecordAgentClass))
#define RECORD_IS_AGENT(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), RECORD_TYPE_AGENT))
#define RECORD_IS_AGENT_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), RECORD_TYPE_AGENT))
#define RECORD_AGENT_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), RECORD_TYPE_AGENT, RecordAgentClass))

typedef struct _RecordAgent		RecordAgent;
typedef struct _RecordAgentClass	RecordAgentClass;
typedef struct _RecordAgentPrivate	RecordAgentPrivate;

struct _RecordAgent
{
  GDBusProxy parent;
  RecordAgentPrivate *priv;
};

struct _RecordAgentClass
{
  GDBusProxyClass parent;
};

GType		record_agent_get_type		(void);

void		record_agent_new		(GDBusConnection     *connection,
						 const gchar         *bus_name,
						 const gchar         *object_path,
						 const gchar         *interface_name,
						 GCancellable        *cancellable,
						 gint                 timeout,
						 GAsyncReadyCallback  callback,
						 gpointer             user_data);
RecordAgent*	record_agent_new_finish		(GAsyncResult        *res,
						 GError             **error);

gboolean	record_agent_login		(RecordAgent       *agent,
						 const gchar         *hostname,
						 const gchar         *ptsname,
						 const gchar         *command,
						 guint16              lookport,
						 GCancellable        *cancellable,
						 GAsyncReadyCallback  callback,
						 gpointer             user_data);
gboolean	record_agent_login_finish	(RecordAgent       *agent,
						 GAsyncResult        *res,
						 GError             **error);

void		record_agent_logout		(RecordAgent       *agent,
						 GCancellable        *cancellable,
						 GAsyncReadyCallback  callback,
						 gpointer             user_data);
void		record_agent_logout_finish	(RecordAgent       *agent,
						 GAsyncResult        *res,
						 GError             **error);

gboolean	record_agent_get_login		(RecordAgent       *agent);

G_END_DECLS

#endif /* __RECORD_AGENT_H__ */
