/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __RECORD_APP_H__
#define __RECORD_APP_H__

#include <termios.h>

#include <glib.h>
#include <glib-object.h>

#include "record-process.h"
#include "record-lookd.h"
#include "record-encoder.h"

G_BEGIN_DECLS

#define RECORD_TYPE_APP			(record_app_get_type ())
#define RECORD_APP(obj)			(G_TYPE_CHECK_INSTANCE_CAST ((obj), RECORD_TYPE_APP, RecordApp))
#define RECORD_APP_CLASS(klass)		(G_TYPE_CHECK_CLASS_CAST ((klass), RECORD_TYPE_APP, RecordAppClass))
#define RECORD_IS_APP(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), RECORD_TYPE_APP))
#define RECORD_IS_APP_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), RECORD_TYPE_APP))
#define RECORD_APP_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), RECORD_TYPE_APP, RecordAppClass))

typedef struct _RecordApp		RecordApp;
typedef struct _RecordAppClass		RecordAppClass;
typedef struct _RecordAppPrivate	RecordAppPrivate;

struct _RecordApp
{
  GObject object;
  RecordAppPrivate *priv;
};

struct _RecordAppClass
{
  GObjectClass parent;
};

typedef enum
{
  AGENT_TYPE_PEER,
  AGENT_TYPE_BUS_SESSION,
  AGENT_TYPE_BUS_SYSTEM,
} AgentType;

GType		record_app_get_type		(void);

RecordApp*	record_app_new			(void);
RecordApp*	record_app_get			(void);

gboolean	record_app_load_config_file	(RecordApp      *app,
						 const gchar    *filename);
GKeyFile*	record_app_get_keyfile		(RecordApp      *app);

gboolean	record_app_start		(RecordApp      *app,
						 const gchar   **argv,
						 struct termios *term_attr);
void		record_app_quit			(RecordApp      *app);

gboolean	record_app_run_script		(RecordApp      *app,
						 const gchar    *filename);

RecordProcess*	record_app_get_process		(RecordApp      *app);
TConsole*	record_app_get_console		(RecordApp      *app);
RecordLookd*	record_app_get_lookd		(RecordApp      *app);
RecordEncoder*	record_app_get_encoder		(RecordApp      *app);

G_END_DECLS

#endif /* __RECORD_APP_H__ */
