/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __RECORD_ENCODER_H__
#define __RECORD_ENCODER_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define RECORD_TYPE_ENCODER		(record_encoder_get_type ())
#define RECORD_ENCODER(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), RECORD_TYPE_ENCODER, RecordEncoder))
#define RECORD_ENCODER_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), RECORD_TYPE_ENCODER, RecordEncoderClass))
#define RECORD_IS_ENCODER(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), RECORD_TYPE_ENCODER))
#define RECORD_IS_ENCODER_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), RECORD_TYPE_ENCODER))
#define RECORD_ENCODER_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), RECORD_TYPE_ENCODER, RecordEncoderClass))

typedef struct _RecordEncoder		RecordEncoder;
typedef struct _RecordEncoderClass	RecordEncoderClass;
typedef struct _RecordEncoderPriv	RecordEncoderPriv;

struct _RecordEncoder
{
  GObject  parent;
  RecordEncoderPriv *priv;
};

struct _RecordEncoderClass
{
  GObjectClass parent;
};

GType		record_encoder_get_type		(void);

RecordEncoder*	record_encoder_new		(const gchar   *pathname,
						 gint           comp_level,
						 const gchar   *creator);
void		record_encoder_set_passwd	(RecordEncoder *encoder,
						 const gchar   *passwd,
						 gssize         length);

const gchar*	record_encoder_get_filename	(RecordEncoder *encoder);
gint		record_encoder_get_comp_level	(RecordEncoder *encoder);
const gchar*	record_encoder_get_creator	(RecordEncoder *encoder);

gboolean	record_encoder_begin		(RecordEncoder *encoder,
						 const gchar   *charset,
						 const gchar   *term,
						 guint16        termrows,
						 guint16        termcols,
						 gdouble        starting);
void		record_encoder_end		(RecordEncoder *encoder,
						 gdouble        duration);

void		record_encoder_inject		(RecordEncoder *encoder,
						 const gchar   *data,
						 gssize         size);
void		record_encoder_inject_with_time	(RecordEncoder *encoder,
						 const gchar   *data,
						 gssize         size,
						 gdouble        elapsed);
void		record_encoder_inject_winsize	(RecordEncoder *encoder,
						 guint16        rows,
						 guint16        cols);

G_END_DECLS

#endif /* __RECORD_ENCODER_H__ */
