/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __RECORD_LOOKD_H__
#define __RECORD_LOOKD_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define RECORD_TYPE_LOOKD		(record_lookd_get_type ())
#define RECORD_LOOKD(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), RECORD_TYPE_LOOKD, RecordLookd))
#define RECORD_LOOKD_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), RECORD_TYPE_LOOKD, RecordLookdClass))
#define RECORD_IS_LOOKD(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), RECORD_TYPE_LOOKD))
#define RECORD_IS_LOOKD_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), RECORD_TYPE_LOOKD))
#define RECORD_LOOKD_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), RECORD_TYPE_LOOKD, RecordLookdClass))

typedef struct _RecordLookd		RecordLookd;
typedef struct _RecordLookdClass	RecordLookdClass;
typedef struct _RecordLookdPriv		RecordLookdPriv;

struct _RecordLookd
{
  GObject  parent;
  RecordLookdPriv *priv;
};

struct _RecordLookdClass
{
  GObjectClass parent;
};

GType		record_lookd_get_type		(void);

RecordLookd*	record_lookd_new		(void);

guint16		record_lookd_get_port		(RecordLookd *lookd);
void		record_lookd_set_port		(RecordLookd *lookd,
						 guint16      port);
guint		record_lookd_get_maxconn	(RecordLookd *lookd);
void		record_lookd_set_maxconn	(RecordLookd *lookd,
						 guint        max_conn);
gboolean	record_lookd_get_writable	(RecordLookd *look);
void		record_lookd_set_writable	(RecordLookd *look,
						 gboolean     writable);

gboolean	record_lookd_start		(RecordLookd *lookd,
						 const gchar *ptsname);
void		record_lookd_stop		(RecordLookd *lookd,
						 gboolean     close_connections);

void		record_lookd_write		(RecordLookd *lookd,
						 const gchar *data,
						 gssize       size);
void		record_lookd_resize		(RecordLookd *lookd,
						 guint16      rows,
						 guint16      cols);

G_END_DECLS

#endif /* __RECORD_LOOKD_H__ */
