/* Copyright (C) 2010 xiaohu<xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <sys/time.h>
#include <unistd.h>
#include <string.h>
#include <utmp.h>

#include "record-utmp.h"

/**
 * record_utmp_record_login_log:
 */
void
record_utmp_record_login_log (void)
{
  struct utmp ut;
  GTimeVal tv;
  const gchar *tty, *p;

  /* user. */
  g_strlcpy (ut.ut_user, g_get_user_name (), sizeof (ut.ut_user));

  /* id. */
  tty = ttyname (STDIN_FILENO);
  if (strncmp (tty, "/dev/pts/", 9) == 0)
    p = tty + 8;
  else if (strncmp (tty, "/dev/", 5) == 0)
    p = tty + 4;
  else
    p = tty;

  g_strlcpy (ut.ut_id, p, sizeof (ut.ut_id));

  /* host. */
  p = g_getenv ("DISPLAY");
  if (p)
    g_strlcpy (ut.ut_host, p, sizeof (ut.ut_host));

  /* time. */
  g_get_current_time (&tv);
  ut.ut_tv.tv_sec  = tv.tv_sec;
  ut.ut_tv.tv_usec = tv.tv_usec;

  /* not all user can write utmp file. */
  if (access (_PATH_UTMP, W_OK) == 0)
    {
      login (&ut);
      return;
    }
}

/**
 * record_utmp_record_logout_log:
 */
void
record_utmp_clear_login_log (const gchar *ttyname)
{
  const gchar *line;
  gchar *base = NULL;

  g_return_if_fail (ttyname);

  /* see glibc source. */
  if (strncmp (ttyname, "/dev/", 5) == 0)
    line = ttyname + 5;	/* Skip the "/dev/".  */
  else
    {
      base = g_path_get_basename (ttyname);
      line = base;
    }
  if (access (_PATH_UTMP, W_OK) == 0)
    {
      logout (line);
      return;
    }
  g_free (base);
}

