#!/usr/local/bin/ttyrcd -s
-- Copyright (c) 2010 xiaohu<xiaohu417@gmail.com>,
-- All rights reserved.
--
-- script demo how to automated FTP download session
--
require "ttyutils"

------------------------------------------------------
-- feed   : feed data to child process
-- expect : wait for process output
------------------------------------------------------
local feed   = record.feed
local expect = function (pattern, timeout)
	local match, spos, epos = record.expect (pattern, timeout)
	record.erase (epos)
	if not match then error ("Expected `" .. pattern .. "' not found.") end
	return match, spos, epos
end

------------------------------------------------------
-- check arguments
------------------------------------------------------
if not arg[1] then
	print ("\r\nArgument missing! please see log for detail.\r\n")
	error ([[
Usage:
  autoftp.lua -a "file" [-l logfile]
or:
  ttyrcd -s "autoftp.lua file" [-l logfile]"]])
end

------------------------------------------------------
-- discard keyboard input
------------------------------------------------------
record.suspend ()

------------------------------------------------------
-- wait for shell command line prompt
------------------------------------------------------
expect (".*@.*[\$#]")

------------------------------------------------------
-- connect host, login, and download file
------------------------------------------------------
feed ("ftp localhost\n")				-- connect
match = expect ("(ftp:.*|Name)", 10)	-- wait for somethings
if not string.find (match, "Name") then error "Unable to connect host." end
feed   ("anonymous\n")					-- login
expect ("Password:")
feed   ("a@a.com\n")
match = expect ("Login.*(incorrect|successful)", 10)
if not string.find (match, "success") then error "Unable to login." end
expect ("ftp>")
feed   ("get " .. arg[1] .. "\n")		-- download file
expect ("ftp>", 600)
feed   ("bye\n")						-- disconnect

------------------------------------------------------
-- reenable keyboard input
------------------------------------------------------
record.resume ()

------------------------------------------------------
-- quit
------------------------------------------------------
record.quit ()
