/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __T_CONSOLE_H__
#define __T_CONSOLE_H__

#include <glib-object.h>

G_BEGIN_DECLS

#define T_TYPE_CONSOLE             (t_console_get_type ())
#define T_CONSOLE(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), T_TYPE_CONSOLE, TConsole))
#define T_CONSOLE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), T_TYPE_CONSOLE, TConsoleClass))
#define T_IS_CONSOLE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), T_TYPE_CONSOLE))
#define T_IS_CONSOLE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), T_TYPE_CONSOLE))
#define T_CONSOLE_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), T_TYPE_CONSOLE, TConsoleClass))

typedef struct _TConsole	TConsole;
typedef struct _TConsoleClass	TConsoleClass;
typedef struct _TConsolePrivate	TConsolePrivate;

struct _TConsole
{
  GObject  object;

  /*< private >*/
  TConsolePrivate *priv;
};

struct _TConsoleClass
{
  GObjectClass object_class;

  void	(*readable)	(TConsole    *console,
			 const gchar *data,
			 guint        size);
};

typedef enum
{
  CONSOLE_SUSPEND_STDIN  = 1 << 0,
  CONSOLE_SUSPEND_STDOUT = 1 << 1,
} TConsoleSuspend;

GType		t_console_get_type		(void);

TConsole*	t_console_new			(void);

gboolean	t_console_start			(TConsole       *console);

gsize		t_console_get_cache_size	(TConsole       *console);
void		t_console_set_cache_size	(TConsole       *console,
						 gsize           size);

gint		t_console_write			(TConsole       *console,
						 const gchar    *buff,
						 gssize          bufflen);
void		t_console_flush			(TConsole       *console);

gint		t_console_get_buffer_size	(TConsole       *console);
void		t_console_clear_buffer		(TConsole       *console);

void		t_console_refresh		(TConsole       *console);
void		t_console_clear_cache		(TConsole       *console);

gboolean	t_console_suspend		(TConsole       *console,
						 TConsoleSuspend suspend,
						 gboolean        suspend_transmis);
gboolean	t_console_resume		(TConsole       *console,
						 TConsoleSuspend resume,
						 gboolean        clear_pending);

G_END_DECLS

#endif /* __T_CONSOLE_H__ */
