/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __T_DECODER_H__
#define __T_DECODER_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define T_TYPE_DECODER             (t_decoder_get_type ())
#define T_DECODER(obj)             (G_TYPE_CHECK_INSTANCE_CAST ((obj), T_TYPE_DECODER, TDecoder))
#define T_DECODER_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST ((klass), T_TYPE_DECODER, TDecoderClass))
#define T_IS_DECODER(obj)          (G_TYPE_CHECK_INSTANCE_TYPE ((obj), T_TYPE_DECODER))
#define T_IS_DECODER_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE ((klass), T_TYPE_DECODER))
#define T_DECODER_GET_CLASS(obj)   (G_TYPE_INSTANCE_GET_CLASS ((obj), T_TYPE_DECODER, TDecoderClass))

typedef struct _TDecoder	TDecoder;
typedef struct _TDecoderClass	TDecoderClass;
typedef struct _TDecoderPrivate	TDecoderPrivate;

struct _TDecoder
{
  GObject  object;
  TDecoderPrivate *priv;
};

struct _TDecoderClass
{
  GObjectClass object_class;
};

typedef gboolean	(*TDecoderPasswdFunc)	(TDecoder           *decoder,
						 gpointer            user_data);


GType		t_decoder_get_type		(void);

TDecoder*	t_decoder_new			(void);

gboolean	t_decoder_open			(TDecoder           *decoder,
						 const gchar        *filename,
						 TDecoderPasswdFunc  passwd_func,
						 gpointer            user_data,
						 GDestroyNotify      destroy,
						 GError            **error);
void		t_decoder_close			(TDecoder           *decoder);


gboolean	t_decoder_set_passwd		(TDecoder           *decoder,
						 const gchar        *passwd,
						 gssize              length);

const gchar*	t_decoder_get_filename		(TDecoder           *decoder);
const gchar*	t_decoder_get_comment		(TDecoder           *decoder,
						 gint               *length);
gpointer	t_decoder_get_archive		(TDecoder           *decoder);

TRecordHead*	t_decoder_get_head		(TDecoder           *decoder);
guint32		t_decoder_get_nindexes		(TDecoder           *decoder);

TRecordIndex*	t_decoder_get_indexes		(TDecoder           *decoder,
						 guint32            *istart,
						 guint32            *iend);
const gchar*	t_decoder_get_data		(TDecoder           *decoder,
						 guint64            *dstart,
						 guint64            *dend);

gboolean	t_decoder_has_index		(TDecoder           *decoder,
						 guint32             index);
gboolean	t_decoder_seek			(TDecoder           *decoder,
						 guint32             index,
						 GError            **error);
const gchar*	t_decoder_get_index_data	(TDecoder           *decoder,
						 guint32             index,
						 guint16            *size,
						 GError            **error);
gdouble		t_decoder_get_index_elapsed	(TDecoder           *decoder,
						 guint32             index,
						 GError            **error);

G_END_DECLS

#endif /* __T_DECODER_H__ */
