/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __T_LOOK_H__
#define __T_LOOK_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define T_TYPE_LOOK		(t_look_get_type ())
#define T_LOOK(obj)		(G_TYPE_CHECK_INSTANCE_CAST ((obj), T_TYPE_LOOK, TLook))
#define T_LOOK_CLASS(klass)	(G_TYPE_CHECK_CLASS_CAST ((klass), T_TYPE_LOOK, TLookClass))
#define T_IS_LOOK(obj)		(G_TYPE_CHECK_INSTANCE_TYPE ((obj), T_TYPE_LOOK))
#define T_IS_LOOK_CLASS(klass)	(G_TYPE_CHECK_CLASS_TYPE ((klass), T_TYPE_LOOK))
#define T_LOOK_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), T_TYPE_LOOK, TLookClass))


typedef struct _TLook		TLook;
typedef struct _TLookClass	TLookClass;
typedef struct _TLookPriv	TLookPriv;
typedef struct _TLookdInfo	TLookdInfo;

struct _TLook
{
  GObject parent;
  TLookPriv *priv;
};

struct _TLookClass
{
  GObjectClass parent;

  void	(*hangup)	(TLook *look);
};

/* when client connect to look service, server will
 * send some information about server itself to client,
 * this struct includes these information. */
struct _TLookdInfo
{
  gchar      ptsname[64];	/* ptsname, for ttylook check recursion. */
  gchar      charset[16];	/* character encoding */
  gchar      term[16];		/* terminal name (TERM env) */
  guint16    termrows;		/* terminal row count */
  guint16    termcols;		/* terminal column count */
  guchar     unused[28];	/* unused */
};

GType		t_look_get_type		(void);

TLook*		t_look_new		(void);

const gchar*	t_look_get_host		(TLook        *look);
void		t_look_set_host		(TLook        *look,
					 const gchar  *host);
guint16		t_look_get_port		(TLook        *look);
void		t_look_set_port		(TLook        *look,
					 guint16       port);
guint		t_look_get_timeout	(TLook        *look);
void		t_look_set_timeout	(TLook        *look,
					 guint         timeout);

TLookdInfo*	t_look_get_info		(TLook        *look);
GCancellable*	t_look_get_cancellable	(TLook        *look);
 
gboolean	t_look_connect		(TLook        *look);

gboolean	t_look_is_connected	(TLook        *look);
void		t_look_disconnect	(TLook        *look);

gboolean	t_look_write		(TLook        *look,
					 const gchar  *data,
					 gssize        size);
gboolean	t_look_read		(TLook        *look);

void		t_look_set_suspension	(TLook        *look,
					 gboolean      suspension);
gboolean	t_look_is_suspension	(TLook        *look);

G_END_DECLS

#endif /* __T_LOOK_H__ */
