/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __T_MACROS_H__
#define __T_MACROS_H__

#include <glib.h>

G_BEGIN_DECLS

/* debug macros.
 * below macros only generating code when DEBUG macro was defined.
 */
# ifdef DEBUG
#  ifdef G_HAVE_ISO_VARARGS
#   define _debug(...)		g_log(G_LOG_DOMAIN, G_LOG_LEVEL_DEBUG,   __VA_ARGS__)
#   define _message(...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_MESSAGE, __VA_ARGS__)
#   define _warning(...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_WARNING, __VA_ARGS__)
#   define _critical(...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_CRITICAL, __VA_ARGS__)
#  elif defined(G_HAVE_GNUC_VARARGS)
#   define _debug(format...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_DEBUG,   format)
#   define _message(format...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_MESSAGE, format)
#   define _warning(format...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_WARNING, format)
#   define _critical(format...)	g_log(G_LOG_DOMAIN, G_LOG_LEVEL_CRITICAL, format)
#  else
#   error "Both ISO_VARARGS and GNUC_VARARGS unusabled ..."
#  endif
# else /* !DEBUG */
#  define _debug(...)
#  define _message(...)
#  define _warning(...)
#  define _critical(...)
# endif

G_END_DECLS

#endif /* __T_MACROS_H__ */
