/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifndef __T_RING_H__
#define __T_RING_H__

#include <glib.h>

G_BEGIN_DECLS

typedef struct _TRing	TRing;

TRing*		t_ring_new		(void);
void		t_ring_free		(TRing       *ring);
void		t_ring_clear		(TRing       *ring);

gint		t_ring_get_nchunks	(TRing       *ring);
gint		t_ring_get_size		(TRing       *ring);

gboolean	t_ring_can_write	(TRing       *ring,
					 gint         size);
gint		t_ring_write		(TRing       *ring,
					 const gchar *buff,
					 gint         size);

gboolean	t_ring_can_read		(TRing       *ring,
					 gint         size);
gint		t_ring_read		(TRing       *ring,
					 gchar       *buff,
					 gint         size);

gboolean	t_ring_can_read_line	(TRing       *ring,
					 gint         size);
gint		t_ring_read_line	(TRing       *ring,
					 gchar       *buff,
					 gint         size);

gint		t_ring_read_to		(TRing       *ring,
					 gchar       *buff,
					 gint         atleast,
					 gint         maxsize,
					 gchar       *str,
					 gint         nstr);
gint		t_ring_read_with	(TRing       *ring,
					 gchar       *buff,
					 gint         atleast,
					 gint         maxsize,
					 gchar       *str,
					 gint         nstr);
gint		t_ring_discard_to	(TRing       *ring,
					 gint         atleast,
					 gint         maxsize,
					 gchar       *str,
					 gint         nstr);
gint		t_ring_discard_with	(TRing       *ring,
					 gint         atleast,
					 gint         maxsize,
					 gchar       *str,
					 gint         nstr);

G_END_DECLS

#endif /* __T_RING_H__ */
