/* Copyright (C) 2010 xiaohu <xiaohu417@gmail.com>,
 * All rights reserved.
 */
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif

#include <stdio.h>
#include <unistd.h>
#include <string.h>
#ifdef HAVE_TERMCAP_H
# include <termcap.h>
#endif
#ifdef HAVE_CURSES_H
# include <curses.h>
#endif
#ifdef HAVE_TERM_H
# include <term.h>
#endif

#include "ttermcap.h"

/**
 * t_term_clear_screen:
 *
 * clear terminal screen.
 */
void
t_term_clear_screen (void)
{
  const gchar *sequence = "\033[H\033[2J";
#if defined (HAVE_TGETENT) && defined (HAVE_TPUTS)
  gchar buff[4096], *ret, *p;
#endif

  if (!isatty (STDOUT_FILENO))
    return;

#if defined (HAVE_TGETENT) && defined (HAVE_TPUTS)
  if (tgetent (buff, g_getenv ("TERM")) != ERR)
    {
      p = buff;
      if ((ret = tgetstr ("cl", &p)) != NULL)
	tputs (ret, 0, putchar);
    }
#endif
  if (write (STDOUT_FILENO, sequence, strlen (sequence)) < 0)
    perror ("write():");
}

/**
 * t_term_reset:
 *
 * reset terminal internal states
 */
void
t_term_reset (void)
{
  g_return_if_fail (isatty (STDOUT_FILENO));

  if (write (STDOUT_FILENO, "\033c", strlen ("\033c")) < 0)
    perror ("write():");
}
